    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------------------------
    028     * BoxAndWhiskerXYToolTipGenerator.java
    029     * ------------------------------------
    030     * (C) Copyright 2003-2008, by David Browning and Contributors.
    031     *
    032     * Original Author:  David Browning;
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034     *
    035     * Changes
    036     * -------
    037     * 05-Aug-2003 : Version 1, contributed by David Browning (DG);
    038     * 13-Aug-2003 : Implemented Cloneable (DG);
    039     * 28-Aug-2003 : Updated for changes in dataset API (DG);
    040     * 25-Feb-2004 : Renamed XYToolTipGenerator --> XYItemLabelGenerator (DG);
    041     * 27-Feb-2004 : Renamed BoxAndWhiskerItemLabelGenerator -->
    042     *               BoxAndWhiskerXYItemLabelGenerator, and modified to use
    043     *               MessageFormat (DG);
    044     * 15-Jul-2004 : Switched getX() with getXValue() and getY() with
    045     *               getYValue() (DG);
    046     * 02-Feb-2007 : Removed author tags all over JFreeChart sources (DG);
    047     *
    048     */
    049
    050    package org.jfree.chart.labels;
    051
    052    import java.io.Serializable;
    053    import java.text.DateFormat;
    054    import java.text.MessageFormat;
    055    import java.text.NumberFormat;
    056    import java.util.Date;
    057
    058    import org.jfree.data.statistics.BoxAndWhiskerXYDataset;
    059    import org.jfree.data.xy.XYDataset;
    060
    061    /**
    062     * An item label generator for plots that use data from a
    063     * {@link BoxAndWhiskerXYDataset}.
    064     * <P>
    065     * The tooltip text and item label text are composed using a
    066     * {@link java.text.MessageFormat} object, that can aggregate some or all of
    067     * the following string values into a message.
    068     * <table>
    069     * <tr><td>0</td><td>Series Name</td></tr>
    070     * <tr><td>1</td><td>X (value or date)</td></tr>
    071     * <tr><td>2</td><td>Mean</td></tr>
    072     * <tr><td>3</td><td>Median</td></tr>
    073     * <tr><td>4</td><td>Minimum</td></tr>
    074     * <tr><td>5</td><td>Maximum</td></tr>
    075     * <tr><td>6</td><td>Quartile 1</td></tr>
    076     * <tr><td>7</td><td>Quartile 3</td></tr>
    077     * </table>
    078     */
    079    public class BoxAndWhiskerXYToolTipGenerator extends StandardXYToolTipGenerator
    080            implements XYToolTipGenerator, Cloneable, Serializable {
    081
    082        /** For serialization. */
    083        private static final long serialVersionUID = -2648775791161459710L;
    084
    085        /** The default tooltip format string. */
    086        public static final String DEFAULT_TOOL_TIP_FORMAT
    087                = "X: {1} Mean: {2} Median: {3} Min: {4} Max: {5} Q1: {6} Q3: {7} ";
    088
    089        /**
    090         * Creates a default item label generator.
    091         */
    092        public BoxAndWhiskerXYToolTipGenerator() {
    093            super(DEFAULT_TOOL_TIP_FORMAT, NumberFormat.getInstance(),
    094                    NumberFormat.getInstance());
    095        }
    096
    097        /**
    098         * Creates a new item label generator.  If the date formatter is not
    099         * <code>null</code>, the x-values will be formatted as dates.
    100         *
    101         * @param toolTipFormat  the tool tip format string (<code>null</code> not
    102         *                       permitted).
    103         * @param numberFormat  the number formatter (<code>null</code> not
    104         *                      permitted).
    105         * @param dateFormat  the date formatter (<code>null</code> permitted).
    106         */
    107        public BoxAndWhiskerXYToolTipGenerator(String toolTipFormat,
    108                                               DateFormat dateFormat,
    109                                               NumberFormat numberFormat) {
    110
    111            super(toolTipFormat, dateFormat, numberFormat);
    112
    113        }
    114
    115        /**
    116         * Creates the array of items that can be passed to the
    117         * {@link MessageFormat} class for creating labels.
    118         *
    119         * @param dataset  the dataset (<code>null</code> not permitted).
    120         * @param series  the series (zero-based index).
    121         * @param item  the item (zero-based index).
    122         *
    123         * @return The items (never <code>null</code>).
    124         */
    125        protected Object[] createItemArray(XYDataset dataset, int series,
    126                                           int item) {
    127            Object[] result = new Object[8];
    128            result[0] = dataset.getSeriesKey(series).toString();
    129            Number x = dataset.getX(series, item);
    130            if (getXDateFormat() != null) {
    131                result[1] = getXDateFormat().format(new Date(x.longValue()));
    132            }
    133            else {
    134                result[1] = getXFormat().format(x);
    135            }
    136            NumberFormat formatter = getYFormat();
    137
    138            if (dataset instanceof BoxAndWhiskerXYDataset) {
    139                BoxAndWhiskerXYDataset d = (BoxAndWhiskerXYDataset) dataset;
    140                result[2] = formatter.format(d.getMeanValue(series, item));
    141                result[3] = formatter.format(d.getMedianValue(series, item));
    142                result[4] = formatter.format(d.getMinRegularValue(series, item));
    143                result[5] = formatter.format(d.getMaxRegularValue(series, item));
    144                result[6] = formatter.format(d.getQ1Value(series, item));
    145                result[7] = formatter.format(d.getQ3Value(series, item));
    146            }
    147            return result;
    148        }
    149
    150        /**
    151         * Tests if this object is equal to another.
    152         *
    153         * @param obj  the other object.
    154         *
    155         * @return A boolean.
    156         */
    157        public boolean equals(Object obj) {
    158            if (obj == this) {
    159                return true;
    160            }
    161            if (!(obj instanceof BoxAndWhiskerXYToolTipGenerator)) {
    162                return false;
    163            }
    164            return super.equals(obj);
    165        }
    166
    167    }